﻿using System;
using System.Threading.Tasks;

namespace AsyncAwait
{
    class Program
    {
        static void ConsoleWriteLine(string s)
        {
            int id = System.Threading.Thread.CurrentThread.ManagedThreadId;
            Console.WriteLine(id.ToString() + " " + s);
        }

        static void Main(string[] args)
        {
            ProgramowanieAsynchroniczne();
            ConsoleWriteLine("Naciśnij ENTER...."); Console.ReadLine();
        }

        static async void ProgramowanieAsynchroniczne()
        {
            Task<long> zadanie = ZróbCośAsync("zadanie-metoda");
            ConsoleWriteLine("Zadanie zostało uruchomione");
            long wynik = zadanie.Result;
            //long wynik = await zadanie;
            ConsoleWriteLine("Zadanie: " + wynik.ToString());
        }

        static Task<long> ZróbCośAsync(object parametr)
        {
            Func<object, long> akcja =
                (object parametr) =>
                {
                    ConsoleWriteLine("Początek działania akcji - " + parametr.ToString());
                    System.Threading.Thread.Sleep(500);
                    ConsoleWriteLine("Koniec działania akcji - " + parametr.ToString());
                    return DateTime.Now.Ticks;
                };

            //long wynik = akcja("Sychroniczne");
            //Console.WriteLine("Synchronicznie: " + wynik.ToString());

            Task<long> zadanie = new Task<long>(akcja, "Zadanie");
            zadanie.Start();
            return zadanie;
        }
    }
}
